VERSION 5.00
Object = "{648A5603-2C6E-101B-82B6-000000000014}#1.1#0"; "MSCOMM32.OCX"
Begin VB.Form Form1 
   BackColor       =   &H00000000&
   BorderStyle     =   4  'Fixed ToolWindow
   Caption         =   "AZimuth Poller"
   ClientHeight    =   0
   ClientLeft      =   45
   ClientTop       =   315
   ClientWidth     =   1530
   BeginProperty Font 
      Name            =   "Arial"
      Size            =   8.25
      Charset         =   0
      Weight          =   400
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   0
   ScaleWidth      =   1530
   StartUpPosition =   2  'CenterScreen
   Begin VB.Timer Timer1 
      Interval        =   1000
      Left            =   720
      Top             =   0
   End
   Begin MSCommLib.MSComm MSComm1 
      Left            =   120
      Top             =   0
      _ExtentX        =   1005
      _ExtentY        =   1005
      _Version        =   393216
      DTREnable       =   -1  'True
   End
   Begin VB.Menu m1 
      Caption         =   "ASCOM"
      Begin VB.Menu choose 
         Caption         =   "Choose"
      End
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private m_scope As Object
Private timerflag As Boolean
Public oPersist As New Persist
Dim strPort As String
Dim strBaud As String
Dim strFormat As String
Dim strStart As String
Dim strStop As String
Dim ID As String

Private Sub connect()
    Dim str As String

    On Error GoTo handleErr
    
    If ID <> "" Then
    
        Set m_scope = CreateObject(ID)
        If Not m_scope Is Nothing Then
            ' if sucessfull then connect
            m_scope.Connected = True
            If Not m_scope.Connected Then
                ' can't connect for some reason - give in!
                Set m_scope = Nothing
            Else
                ' initialise com port
                If MSComm1.PortOpen = False Then
                    MSComm1.CommPort = Val(Right$(strPort, Len(strPort) - 3))
                    MSComm1.Settings = strBaud
                    MSComm1.PortOpen = True
                    ' if port opened ok
                    If MSComm1.PortOpen = True Then
                        ' set poll timer ticking
                        str = oPersist.ReadIniValue("interval")
                        If str = "" Then
                            Call oPersist.WriteIniValue("interval", "1000")
                            Timer1.Interval = 1000
                        Else
                            Timer1.Interval = Val(str)
                        End If
                        Timer1.Enabled = True
                    End If
                End If
            End If
        End If
    End If
    Exit Sub
    
handleErr:
    MsgBox "Error: " & Err.Number & " " & Err.Description

End Sub


Private Sub choose_Click()
    Dim Chsr As DriverHelper.Chooser
      
    Timer1.Enabled = False
    
    ' disconnect current scope
    If Not m_scope Is Nothing Then
        m_scope.Connected = False
        Set m_scope = Nothing
    End If
    
    ' Get an ASCOM "chooser" object
    Set Chsr = New DriverHelper.Chooser
    ' Set the ASCOM driver type
    Chsr.DeviceType = "Telescope"
    If ID = "" Then ID = "EQMOD.Telescope"
    ' open up the chooser dialog
    ID = Chsr.choose(ID)
    
    If ID <> "" Then
        Call connect
    End If

    ' write id to ini file
    Call oPersist.WriteIniValue("id", ID)
    
End Sub

Private Sub Form_Load()

    Dim Chsr As DriverHelper.Chooser

    On Error GoTo handleErr

    timerflag = False
    
    strFormat = oPersist.ReadIniValue("format")
    If strFormat = "" Then
        Call oPersist.WriteIniValue("format", "000.00000")
        strFormat = "000.00000"
    End If
    
    strStart = oPersist.ReadIniValue("start")
    strStop = oPersist.ReadIniValue("stop")
    
    strPort = oPersist.ReadIniValue("comport")
    If strPort = "" Then
        Call oPersist.WriteIniValue("comport", "COM1")
        strPort = "COM1"
    End If
    
    strBaud = oPersist.ReadIniValue("baud")
    If strBaud = "" Then
        Call oPersist.WriteIniValue("baud", "9600,n,8,1")
        strBaud = "9600,n,8,1"
    End If
    
    ID = oPersist.ReadIniValue("id")
   
   
    ' stop poll timer
    Timer1.Enabled = False
    
    ' close port if already open
    If MSComm1.PortOpen = True Then
        MSComm1.PortOpen = False
    End If

    If ID <> "" Then
        ' get a scope object for the selected driver
        ' connect to scope
        Call connect
    Else
        Call choose_Click
    End If
    
    Exit Sub
    
handleErr:
    MsgBox "Error: " & Err.Number & " " & Err.Description
   
   
End Sub

Private Sub Timer1_Timer()
Dim strOut As String

On Error GoTo endtimer

    If Not timerflag Then
        timerflag = True
        If Not m_scope Is Nothing Then
            If m_scope.Connected Then
                If MSComm1.PortOpen = True Then
                    ' get azimuth from scope make up a message
                    ' example
                    ':180.99
                    strOut = strStart & Format$(m_scope.Azimuth, strFormat) & strStop & vbCrLf
                    ' send azimuth out of port
                    MSComm1.Output = strOut
                End If
            End If
        End If
    End If
endtimer:
    timerflag = False
    
End Sub
